<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: ALM_RequerimientoDetalle.xml */
/* Generado: 2021-08-12 07:46:43 */

/* Mantenimiento de los registros de la tabla ALM_RequerimientoDetalle */
abstract class BaseALM_RequerimientoDetalleDP extends ALM_RequerimientoDetalleBV
{
    /* Constructor ( Establece los valores desde un objeto ALM_RequerimientoDetalleBN ) */
    public function __construct( ALM_RequerimientoDetalleBN $o_ALM_RequerimientoDetalleBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_ALM_RequerimientoDetalleBN ) )
        {
            $this->setByBN( $o_ALM_RequerimientoDetalleBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto ALM_RequerimientoDetalleBN */
    public function setByBN( ALM_RequerimientoDetalleBN $o_ALM_RequerimientoDetalleBN )
    {
        if ( !is_null( $o_ALM_RequerimientoDetalleBN->getIdRequerimientoDetalle() ) )
        {
            $this->setIdRequerimientoDetalle( $o_ALM_RequerimientoDetalleBN->getIdRequerimientoDetalle() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleBN->getIdRequerimiento() ) )
        {
            $this->setIdRequerimiento( $o_ALM_RequerimientoDetalleBN->getIdRequerimiento() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleBN->getIdItem() ) )
        {
            $this->setIdItem( $o_ALM_RequerimientoDetalleBN->getIdItem() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleBN->getCantidadSugerida() ) )
        {
            $this->setCantidadSugerida( $o_ALM_RequerimientoDetalleBN->getCantidadSugerida() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleBN->getCantidadPedida() ) )
        {
            $this->setCantidadPedida( $o_ALM_RequerimientoDetalleBN->getCantidadPedida() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleBN->getIdMoneda() ) )
        {
            $this->setIdMoneda( $o_ALM_RequerimientoDetalleBN->getIdMoneda() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleBN->getIdLote() ) )
        {
            $this->setIdLote( $o_ALM_RequerimientoDetalleBN->getIdLote() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleBN->getFechaVencimiento() ) )
        {
            $this->setFechaVencimiento( $o_ALM_RequerimientoDetalleBN->getFechaVencimiento() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleBN->getStockMinimo() ) )
        {
            $this->setStockMinimo( $o_ALM_RequerimientoDetalleBN->getStockMinimo() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleBN->getStockMaximo() ) )
        {
            $this->setStockMaximo( $o_ALM_RequerimientoDetalleBN->getStockMaximo() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleBN->getPrecioUnitario() ) )
        {
            $this->setPrecioUnitario( $o_ALM_RequerimientoDetalleBN->getPrecioUnitario() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleBN->getPrecioUnitarioIGV() ) )
        {
            $this->setPrecioUnitarioIGV( $o_ALM_RequerimientoDetalleBN->getPrecioUnitarioIGV() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleBN->getPrecioSubTotal() ) )
        {
            $this->setPrecioSubTotal( $o_ALM_RequerimientoDetalleBN->getPrecioSubTotal() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleBN->getValorIGV() ) )
        {
            $this->setValorIGV( $o_ALM_RequerimientoDetalleBN->getValorIGV() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleBN->getPrecioTotalConIGV() ) )
        {
            $this->setPrecioTotalConIGV( $o_ALM_RequerimientoDetalleBN->getPrecioTotalConIGV() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleBN->getEstado() ) )
        {
            $this->setEstado( $o_ALM_RequerimientoDetalleBN->getEstado() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleBN->getIGVExoneradoFlag() ) )
        {
            $this->setIGVExoneradoFlag( $o_ALM_RequerimientoDetalleBN->getIGVExoneradoFlag() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_ALM_RequerimientoDetalleBN->getFechaCreacion() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_ALM_RequerimientoDetalleBN->getUsuarioCreacion() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleBN->getUsuarioModificacion() ) )
        {
            $this->setUsuarioModificacion( $o_ALM_RequerimientoDetalleBN->getUsuarioModificacion() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleBN->getFechaModificacion() ) )
        {
            $this->setFechaModificacion( $o_ALM_RequerimientoDetalleBN->getFechaModificacion() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_ALM_RequerimientoDetalleFN = new ALM_RequerimientoDetalleFN();
        $o_ALM_RequerimientoDetalleBN = $o_ALM_RequerimientoDetalleFN->selectByPk( $this->getIdRequerimientoDetalle() );
        if ( is_null( $o_ALM_RequerimientoDetalleBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO ALM_RequerimientoDetalle ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getIdRequerimientoDetalle() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdRequerimientoDetalle";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdRequerimientoDetalle()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdRequerimiento() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdRequerimiento";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdRequerimiento()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdItem() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdItem";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdItem()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCantidadSugerida() ) )
            {
                $s_SQLQuery1 .= $s_Separator."CantidadSugerida";
                $s_SQLQuery2 .= $s_Separator."".$this->getCantidadSugerida()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCantidadPedida() ) )
            {
                $s_SQLQuery1 .= $s_Separator."CantidadPedida";
                $s_SQLQuery2 .= $s_Separator."".$this->getCantidadPedida()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdMoneda() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdMoneda";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdMoneda()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdLote() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdLote";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdLote()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaVencimiento() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaVencimiento";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaVencimiento()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getStockMinimo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."StockMinimo";
                $s_SQLQuery2 .= $s_Separator."".$this->getStockMinimo()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getStockMaximo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."StockMaximo";
                $s_SQLQuery2 .= $s_Separator."".$this->getStockMaximo()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioUnitario() ) )
            {
                $s_SQLQuery1 .= $s_Separator."PrecioUnitario";
                $s_SQLQuery2 .= $s_Separator."".$this->getPrecioUnitario()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioUnitarioIGV() ) )
            {
                $s_SQLQuery1 .= $s_Separator."PrecioUnitarioIGV";
                $s_SQLQuery2 .= $s_Separator."".$this->getPrecioUnitarioIGV()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioSubTotal() ) )
            {
                $s_SQLQuery1 .= $s_Separator."PrecioSubTotal";
                $s_SQLQuery2 .= $s_Separator."".$this->getPrecioSubTotal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getValorIGV() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ValorIGV";
                $s_SQLQuery2 .= $s_Separator."".$this->getValorIGV()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioTotalConIGV() ) )
            {
                $s_SQLQuery1 .= $s_Separator."PrecioTotalConIGV";
                $s_SQLQuery2 .= $s_Separator."".$this->getPrecioTotalConIGV()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Estado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIGVExoneradoFlag() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IGVExoneradoFlag";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIGVExoneradoFlag()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE ALM_RequerimientoDetalle SET ";
            $s_Separator = "";
            if ( !is_null( $this->getIdRequerimiento() ) )
            {
                $s_SQLQuery .= $s_Separator."IdRequerimiento = ".$this->getIdRequerimiento()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdItem() ) )
            {
                $s_SQLQuery .= $s_Separator."IdItem = '".$this->getIdItem()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCantidadSugerida() ) )
            {
                $s_SQLQuery .= $s_Separator."CantidadSugerida = ".$this->getCantidadSugerida()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCantidadPedida() ) )
            {
                $s_SQLQuery .= $s_Separator."CantidadPedida = ".$this->getCantidadPedida()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdMoneda() ) )
            {
                $s_SQLQuery .= $s_Separator."IdMoneda = '".$this->getIdMoneda()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdLote() ) )
            {
                $s_SQLQuery .= $s_Separator."IdLote = '".$this->getIdLote()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaVencimiento() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaVencimiento = '".$this->getFechaVencimiento()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getStockMinimo() ) )
            {
                $s_SQLQuery .= $s_Separator."StockMinimo = ".$this->getStockMinimo()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getStockMaximo() ) )
            {
                $s_SQLQuery .= $s_Separator."StockMaximo = ".$this->getStockMaximo()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioUnitario() ) )
            {
                $s_SQLQuery .= $s_Separator."PrecioUnitario = ".$this->getPrecioUnitario()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioUnitarioIGV() ) )
            {
                $s_SQLQuery .= $s_Separator."PrecioUnitarioIGV = ".$this->getPrecioUnitarioIGV()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioSubTotal() ) )
            {
                $s_SQLQuery .= $s_Separator."PrecioSubTotal = ".$this->getPrecioSubTotal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getValorIGV() ) )
            {
                $s_SQLQuery .= $s_Separator."ValorIGV = ".$this->getValorIGV()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioTotalConIGV() ) )
            {
                $s_SQLQuery .= $s_Separator."PrecioTotalConIGV = ".$this->getPrecioTotalConIGV()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery .= $s_Separator."Estado = '".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIGVExoneradoFlag() ) )
            {
                $s_SQLQuery .= $s_Separator."IGVExoneradoFlag = '".$this->getIGVExoneradoFlag()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCreacion = '".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioCreacion = '".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioModificacion = '".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaModificacion = '".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  IdRequerimientoDetalle = ".$this->getIdRequerimientoDetalle().";";
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM ALM_RequerimientoDetalle WHERE  IdRequerimientoDetalle = ".$this->getIdRequerimientoDetalle().";";
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        return true;
    }

}
?>